"use strict";

this.name = "wildships-market";
this.author = "spara";
this.copyright = "2015 spara";
this.license     = "CC BY-NC-SA 4.0"; 

this.$originalResearch = {
	"food" : [0, 0, 17, -2, -2, 2, 1, 1, 0],
	"textiles" : [0, 0, 18, -1, -1, 3, 3, 3, 0],
	"radioactives" : [0, 0, 85, -3, -3, 5, 7, 7, 0],
	"slaves" : [0, 0, 40, -5, -5, 0, 31, 31, 0],
	"liquor_wines" : [0, 0, 90, -5, -5, 251, 15, 15, 0],
	"luxuries" : [0, 0, 170, 8, 8, 10, 3, 3, 0],
	"narcotics" : [0, 0, 245, 29, 8, 0, 10, 120, 0],
	"computers" : [0, 0, 170, 14, 14, 60, 3, 3, 0],
	"machinery" : [0, 0, 130, 6, 6, 40, 7, 7, 0],
	"alloys" : [0, 0, 85, 1, 1, 30, 31, 31, 0],
	"firearms" : [0, 0, 85, 13, 13, 5, 7, 7, 0],
	"furs" : [0, 0, 80, -9, -9, 100, 63, 63, 0],
	"minerals" : [0, 0, 32, -1, -1, 60, 3, 3, 0],
	"gold" : [0, 0, 105, -1, -1, 66, 7, 7, 1],
	"platinum" : [0, 0, 190, -2, -2, 55, 31, 31, 1],
	"gem_stones" : [0, 0, 55, -1, -1, 250, 15, 15, 2],
	"alien_items" : [0, 0, 95, 15, 0, 0, 7, 0, 0]
}

this.$originalManufacturing = {
	"food" : [0, 0, 23, -2, -2, 3, 1, 1, 0],
	"textiles" : [0, 0, 25, -1, -1, 6, 3, 3, 0],
	"radioactives" : [0, 0, 55, -3, -3, 2, 7, 7, 0],
	"slaves" : [0, 0, 45, -5, -5, 226, 31, 31, 0],
	"liquor_wines" : [0, 0, 83, -5, -5, 245, 15, 15, 0],
	"luxuries" : [0, 0, 165, 8, 8, 58, 3, 3, 0],
	"narcotics" : [0, 0, 235, 29, 8, 0, 10, 120, 0],
	"computers" : [0, 0, 130, 14, 14, 60, 3, 3, 0],
	"machinery" : [0, 0, 100, 6, 6, 55, 7, 7, 0],
	"alloys" : [0, 0, 85, 1, 1, 25, 31, 31, 0],
	"firearms" : [0, 0, 124, 13, 13, 29, 7, 7, 0],
	"furs" : [0, 0, 180, -9, -9, 220, 63, 63, 0],
	"minerals" : [0, 0, 35, -1, -1, 53, 3, 3, 0],
	"gold" : [0, 0, 100, -1, -1, 66, 7, 7, 1],
	"platinum" : [0, 0, 180, -2, -2, 55, 31, 31, 1],
	"gem_stones" : [0, 0, 48, -1, -1, 250, 15, 15, 2],
	"alien_items" : [0, 0, 53, 15, 0, 0, 7, 0, 0]
}

this.$originalBio = {
	"food" : [0, 0, 16, -2, -2, 12, 1, 1, 0],
	"textiles" : [0, 0, 24, -1, -1, 12, 3, 3, 0],
	"radioactives" : [0, 0, 69, -3, -3, 3, 7, 7, 0],
	"slaves" : [0, 0, 40, -5, -5, 226, 31, 31, 0],
	"liquor_wines" : [0, 0, 83, -5, -5, 251, 15, 15, 0],
	"luxuries" : [0, 0, 199, 8, 8, 50, 3, 3, 0],
	"narcotics" : [0, 0, 235, 29, 6, 2, 10, 120, 0],
	"computers" : [0, 0, 159, 14, 14, 45, 3, 3, 0],
	"machinery" : [0, 0, 123, 6, 6, 30, 7, 7, 0],
	"alloys" : [0, 0, 82, 1, 1, 12, 31, 31, 0],
	"firearms" : [0, 0, 124, 13, 13, 29, 7, 7, 0],
	"furs" : [0, 0, 176, -9, -9, 220, 63, 63, 0],
	"minerals" : [0, 0, 32, -1, -1, 53, 3, 3, 0],
	"gold" : [0, 0, 97, -1, -1, 66, 7, 7, 1],
	"platinum" : [0, 0, 171, -2, -2, 55, 31, 31, 1],
	"gem_stones" : [0, 0, 45, -1, -1, 250, 15, 15, 2],
	"alien_items" : [0, 0, 53, 15, 0, 0, 7, 0, 0]
}

this.$originalOther = {
	"food" : [0, 0, 19, -2, -2, 2, 1, 1, 0],
	"textiles" : [0, 0, 20, -1, -1, 4, 3, 3, 0],
	"radioactives" : [0, 0, 65, -3, -3, 1, 7, 7, 0],
	"slaves" : [0, 0, 40, -5, -5, 226, 31, 31, 0],
	"liquor_wines" : [0, 0, 83, -5, -5, 245, 15, 15, 0],
	"luxuries" : [0, 0, 196, 8, 8, 48, 3, 3, 0],
	"narcotics" : [0, 0, 235, 29, 8, 1, 10, 120, 0],
	"computers" : [0, 0, 154, 14, 14, 47, 3, 3, 0],
	"machinery" : [0, 0, 117, 6, 6, 35, 7, 7, 0],
	"alloys" : [0, 0, 78, 1, 1, 14, 31, 31, 0],
	"firearms" : [0, 0, 124, 13, 13, 12, 7, 7, 0],
	"furs" : [0, 0, 176, -9, -9, 200, 63, 63, 0],
	"minerals" : [0, 0, 32, -1, -1, 33, 3, 3, 0],
	"gold" : [0, 0, 97, -1, -1, 43, 7, 7, 1],
	"platinum" : [0, 0, 171, -2, -2, 35, 31, 31, 1],
	"gem_stones" : [0, 0, 45, -1, -1, 230, 15, 15, 2],
	"alien_items" : [0, 0, 53, 15, 0, 0, 7, 0, 0]
}

this.$originalDefault = {
	"food" : [0, 0, 19, -2, -2, 6, 1, 1, 0],
	"textiles" : [0, 0, 20, -1, -1, 10, 3, 3, 0],
	"radioactives" : [0, 0, 65, -3, -3, 2, 7, 7, 0],
	"slaves" : [0, 0, 40, -5, -5, 226, 31, 31, 0],
	"liquor_wines" : [0, 0, 83, -5, -5, 251, 15, 15, 0],
	"luxuries" : [0, 0, 196, 8, 8, 54, 3, 3, 0],
	"narcotics" : [0, 0, 235, 29, 29, 8, 120, 120, 0],
	"computers" : [0, 0, 154, 14, 14, 56, 3, 3, 0],
	"machinery" : [0, 0, 117, 6, 6, 40, 7, 7, 0],
	"alloys" : [0, 0, 78, 1, 1, 17, 31, 31, 0],
	"firearms" : [0, 0, 124, 13, 13, 29, 7, 7, 0],
	"furs" : [0, 0, 176, -9, -9, 220, 63, 63, 0],
	"minerals" : [0, 0, 32, -1, -1, 53, 3, 3, 0],
	"gold" : [0, 0, 97, -1, -1, 66, 7, 7, 1],
	"platinum" : [0, 0, 171, -2, -2, 55, 31, 31, 1],
	"gem_stones" : [0, 0, 45, -1, -1, 250, 15, 15, 2],
	"alien_items" : [0, 0, 53, 15, 0, 0, 7, 0, 0]
}

this.updateLocalCommodityDefinition = function(goodDefinition, station) {
	
	var commodity = goodDefinition.key;
	goodDefinition.capacity = 63;
	
	//Research stations
	if (station.hasRole("wildShips_kiota2Spur") || station.hasRole("wildShips_kiota4Spur")) {
		var oldDefs = this.$originalResearch[commodity];
	}
	//Manufacturing stations  
	else if (station.hasRole("wildShips_kiota2Disc") || station.hasRole("wildShips_kiota4Disc")) {
		var oldDefs = this.$originalManufacturing[commodity];
	}
	//Biosphere stations
	else if (station.hasRole("wildShips_kiota2Sphere") || station.hasRole("wildShips_kiota4Sphere")) {
		var oldDefs = this.$originalBio[commodity];
	}
	//Other stations
	else if (station.hasRole("wildShips_kiota2Comms") || station.hasRole("wildShips_kiota4Comms") || station.hasRole("wildShips_kiota2Solar") || station.hasRole("wildShips_kiota4Solar")) {
		var oldDefs = this.$originalOther[commodity];
	}
	//Stations with the default market
	else {
		var oldDefs = this.$originalDefault[commodity];
	}
	
	//old style definition found for the good. calculate it the old way
	if (oldDefs) {
		var market_base_price = oldDefs[2];
		var market_eco_adjust_price = oldDefs[3];
		var market_eco_adjust_quantity = oldDefs[4];
		var market_base_quantity = oldDefs[5];
		var market_mask_price = oldDefs[6];
		var market_mask_quantity = oldDefs[7];
		var market_rnd = Math.floor(Math.random() * 256);

		var economy = system.economy;
		
		var price = (market_base_price + (market_rnd & market_mask_price) + (economy * market_eco_adjust_price)) & 255;
		
		price *= 0.4;
		
		var quantity = (market_base_quantity + (market_rnd & market_mask_quantity) - (economy * market_eco_adjust_quantity)) & 255;
		if (quantity > 127) quantity = 0;
		
		quantity &= 63;
		
		
		
		goodDefinition.quantity = quantity;
		goodDefinition.price = price * 10;
	}
	//no definition found. just add some variance to the system market (+/-5%)
	else {
		goodDefinition.price = goodDefinition.price * (1.05 - Math.random() * 0.1);
		goodDefinition.quantity = Math.floor(goodDefinition.quantity * (1.05 - Math.random() * 0.1));
	}
	//scale down if quantity too high
	if (goodDefinition.quantity > goodDefinition.capacity)
		goodDefinition.quantity = Math.floor(goodDefinition.quantity / 127 * goodDefinition.capacity);

	return goodDefinition;
};
